/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.lms;

import java.io.File;
import java.util.Properties;
import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerAction;
import jp.co.ntt.lms.installer.core.InstallerActionValue;
import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.core.util.InstallerCheckUtil;
import jp.co.ntt.lms.installer.core.util.InstallerPropertiesUtil;
import jp.co.ntt.lms.installer.core.util.InstallerUiUtil;
import jp.co.ntt.lms.installer.util.FileUtil;
import jp.co.ntt.lms.installer.util.LoggerUtil;
import jp.co.ntt.lms.installer.util.StringUtil;

/**
 * XCalat設定ファイルの書換項目について入力を求めるアクションクラス。
 * @author T.Nishiki
 */
public class XcalatInputAction implements InstallerAction {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(XcalatInputAction.class);
	}

	/**
	 * アクションをスキップするか判定します。<br>
	 * SelectLoActionでの入力に基づき判定します。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return LO選択でPerceptionを選択されていなければtrueを戻します。
	 * @throws InstallerException 判定の元となる情報取得に失敗した場合。
	 * @see SelectLoAction
	 */
	public boolean isSkipped(InstallerValues values)
			throws InstallerException {
		LoggerUtil.methodHead(_logger, "isSkipped(InstallerValues)");

		boolean skipped = false;
		try {
			// LO選択でXcalatを未選択にしていれいばtrue。
			skipped = (values.getOptionLOSelected(
					XcalatInputValue.KEY_LO) == false);
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		LoggerUtil.methodTail(_logger, "isSkipped(InstallerValues)", skipped);
		return skipped;
	}

	/**
	 * XCalatサーバ設定ファイルの書換項目について入力・確認を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return XcalatInputValueを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 * @see XcalatInputValue
	 */
	public InstallerActionValue action(InstallerValues values)
		throws InstallerException {

		LoggerUtil.methodHead(_logger, "action(InstallerValues)");

		// 今回入力データ
		XcalatInputValue inputValue = null;
		try {
			// 既存入力データ（デフォルトデータとして使用）
			XcalatInputValue defaultValue = getDefaultValue(values);
			// タイトル表示
			InstallerUiUtil.outputMessageAsTitle(
				values, "XcalatInputAction.welcome");

			while (true) {
				// 入力実行
				inputValue = readInputValue(values, defaultValue);
				// 入力確認
				if (confirmInputValue(values, inputValue) == true) {
					// 入力確認が済んだ場合、指定されたディレクトリを
					// 作成対象として登録する。
					File dir = new File(inputValue.getMaterialInstallPath());
					values.addMadeDirectory(dir);
					break;
				}
			}
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger, "action(InstallerValues)", inputValue);
		return inputValue;
	}


	/**
	 * Xcalat設定ファイルの書換項目について入力を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param defaultValue デフォルト値。
	 * @return 入力された内容をXcalatInputValueとして戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private XcalatInputValue readInputValue(
			InstallerValues values, XcalatInputValue defaultValue)
			throws InstallerException {
		LoggerUtil.methodHead(_logger,
			"readInputValue(InstallerValues)");

		XcalatInputValue inputValue = null;
		try {
			inputValue = new XcalatInputValue();
			////////////////////////////////////////////////////////////////////
			// サーバ設定
			// =================================================================
			// デフォルトのサーバ名を取得
			String[] defaultServerNames = defaultValue.getServerNames();
			// =================================================================
			// サーバ数
			int serverNumber = 0;
			do {
				serverNumber = InstallerUiUtil.askUserInputInteger(
						values,	"XcalatInputAction.prompt.serverNumber");
			} while (serverNumber <= 0);
			// =================================================================
			// サーバの数だけ入力
			for (int i = 0; i < serverNumber ; i++) {
				// =============================================================
				// ホスト名
				String defaultServerName = null;
				if (i < defaultServerNames.length) {
					defaultServerName = defaultServerNames[i];
				}
				String serverName = null;
				while (true) {
					serverName = InstallerUiUtil.askUserInput(values,
							"XcalatInputAction.prompt.serverName",
							defaultServerName);
					// 未入力
					if (InstallerCheckUtil.isEmptyViolation(serverName, values,
							"XcalatInputAction.error.serverName.empty")) {
						continue;
					}
					break;
				}
				inputValue.addServerName(serverName);
			}
			////////////////////////////////////////////////////////////////////
			// 教材格納ディレクトリ
			String materialInstallPath = null;
			while (true) {
				materialInstallPath = InstallerUiUtil.askUserInput(
						values,
						"XcalatInputAction.prompt.materialInstallPath",
						defaultValue.getMaterialInstallPath());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(
						materialInstallPath, values,
						"XcalatInputAction.error.materialInstallPath.empty")) {
					continue;
				}
				// ディレクトリチェック
				if (InstallerCheckUtil.isFilePath(
						materialInstallPath, values,
						"XcalatInputAction.error.materialInstallPath.file")) {
					continue;
				}
				break;
			}
			inputValue.setMaterialInstallPath(materialInstallPath);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"readInputValue(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * 入力した内容を表示し、ユーザに確認を求めます。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param inputValue 入力された内容
	 * @return 入力された内容にユーザ確認がとれた場合true、
	 *          とれなかった場合falseを戻します。
	 * @throws InstallerException 処理中にエラーが発生した場合。
	 */
	private boolean confirmInputValue(
			InstallerValues values, XcalatInputValue inputValue)
			throws InstallerException {

		LoggerUtil.methodHead(_logger,
			"confirmInputValue(InstallerValues, XcalatInputValue)");
		boolean confirm = false;
		try {
			InstallerUiUtil.outputConfirmTitle(values,
				"XcalatInputAction.confirm.title");
			// =================================================================
			// 入力内容の表示
			// =================================================================
			// Xcalatホスト名
			String[] serverNames = inputValue.getServerNames();
			for ( int i = 0; i < serverNames.length; i++ ) {
				Object[] messageParams = new Object[] {
					new Integer(i + 1)
				};
				InstallerUiUtil.outputConfirm(values,
					"XcalatInputAction.confirm.serverName",
					messageParams,
					serverNames[i]);
			}
			// =================================================================
			// 教材格納ディレクトリ
			InstallerUiUtil.outputConfirm(values,
				"XcalatInputAction.confirm.materialInstallPath",
				inputValue.getMaterialInstallPath());
			// =================================================================
			// ユーザ確認
			confirm = InstallerUiUtil.askUserConfirm(
				values, "XcalatInputAction.confirm" );
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"confirmInputValue(InstallerValues, XcalatInputValue)", confirm);
		return confirm;
	}

	/**
	 * 既存のデータから、入力項目のデフォルト値を取得します。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return デフォルト値をXcalatInputValueの形で戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private XcalatInputValue getDefaultValue(InstallerValues values)
			throws InstallerException {
		// メソッド開始ログ
		LoggerUtil.methodHead(_logger,
			"getDefaultValue(InstallerValues)");

		XcalatInputValue defaultValue = null;
		try {
			defaultValue = new XcalatInputValue();
			////////////////////////////////////////////////////////////////////
			// プロパティの取得
			// =================================================================
			// 既存の内容
			File existFile = values.getFileOnSystem(
					defaultValue.getTargetFileKey());
			Properties existProperties
				= FileUtil.loadAsProperties(existFile);
			// =================================================================
			// リソース（原本）の内容
			Properties resourceProperties
				= InstallerPropertiesUtil.load(
					values, defaultValue.getTargetFileKey());
			////////////////////////////////////////////////////////////////////
			// デフォルト値の設定
			// =================================================================
			// ホスト名
			for (int i = 0; true; i++) {
				// 既存の情報を取得し、設定されていなければ終了。
				String existServerName = existProperties.getProperty(
					XcalatInputValue.KEY_PREFIX_SERVER_NAME + (i + 1));
				if (StringUtil.isEmpty(existServerName)) {
					break;
				}
				String serverName
					= InstallerPropertiesUtil.determineInitialValue(
						existProperties, resourceProperties,
						XcalatInputValue.KEY_PREFIX_SERVER_NAME + (i + 1));
				defaultValue.addServerName(serverName);
			}
			// =================================================================
			// 教材格納ディレクトリ
			String materialInstallPath
				= InstallerPropertiesUtil.determineInitialValue(
					existProperties, resourceProperties,
					XcalatInputValue.KEY_MATERIAL_INSTALL_PATH);
			defaultValue.setMaterialInstallPath(materialInstallPath);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger,
			"getDefaultValue(InstallerValues)", defaultValue);
		return defaultValue;
	}
}
